// Borland C++ Builder
// Copyright (c) 1995, 2002 by Borland Software Corporation
// All rights reserved

// (DO NOT EDIT: machine generated header) 'MRUList.pas' rev: 6.00

#ifndef MRUListHPP
#define MRUListHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <Placemnt.hpp>	// Pascal unit
#include <Registry.hpp>	// Pascal unit
#include <IniFiles.hpp>	// Pascal unit
#include <Menus.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Mrulist
{
//-- type declarations -------------------------------------------------------
typedef void __fastcall (__closure *TGetItemEvent)(System::TObject* Sender, AnsiString &Caption, Classes::TShortCut &ShortCut, int UserData);

typedef void __fastcall (__closure *TReadItemEvent)(System::TObject* Sender, System::TObject* IniFile, const AnsiString Section, int Index, AnsiString &RecentName, int &UserData);

typedef void __fastcall (__closure *TWriteItemEvent)(System::TObject* Sender, System::TObject* IniFile, const AnsiString Section, int Index, const AnsiString RecentName, int UserData);

typedef void __fastcall (__closure *TClickMenuEvent)(System::TObject* Sender, const AnsiString RecentName, const AnsiString Caption, int UserData);

#pragma option push -b-
enum TAccelDelimiter { adTab, adSpace };
#pragma option pop

#pragma option push -b-
enum TRecentMode { rmInsert, rmAppend };
#pragma option pop

class DELPHICLASS TMRUManager;
class PASCALIMPLEMENTATION TMRUManager : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	Classes::TStrings* FList;
	Classes::TList* FItems;
	Placemnt::TIniLink* FIniLink;
	Word FSeparateSize;
	bool FAutoEnable;
	bool FAutoUpdate;
	bool FShowAccelChar;
	bool FRemoveOnSelect;
	unsigned FStartAccel;
	TAccelDelimiter FAccelDelimiter;
	Menus::TMenuItem* FRecentMenu;
	Classes::TNotifyEvent FOnChange;
	TGetItemEvent FOnGetItem;
	TClickMenuEvent FOnClick;
	TReadItemEvent FOnReadItem;
	TWriteItemEvent FOnWriteItem;
	void __fastcall ListChanged(System::TObject* Sender);
	void __fastcall ClearRecentMenu(void);
	void __fastcall SetRecentMenu(Menus::TMenuItem* Value);
	void __fastcall SetSeparateSize(Word Value);
	Placemnt::TFormPlacement* __fastcall GetStorage(void);
	void __fastcall SetStorage(Placemnt::TFormPlacement* Value);
	int __fastcall GetCapacity(void);
	void __fastcall SetCapacity(int Value);
	TRecentMode __fastcall GetMode(void);
	void __fastcall SetMode(TRecentMode Value);
	void __fastcall SetStartAccel(unsigned Value);
	void __fastcall SetShowAccelChar(bool Value);
	void __fastcall SetAccelDelimiter(TAccelDelimiter Value);
	void __fastcall SetAutoEnable(bool Value);
	void __fastcall AddMenuItem(Menus::TMenuItem* Item);
	void __fastcall MenuItemClick(System::TObject* Sender);
	void __fastcall IniSave(System::TObject* Sender);
	void __fastcall IniLoad(System::TObject* Sender);
	void __fastcall InternalLoad(System::TObject* Ini, const AnsiString Section);
	void __fastcall InternalSave(System::TObject* Ini, const AnsiString Section);
	
protected:
	DYNAMIC void __fastcall Change(void);
	virtual void __fastcall Notification(Classes::TComponent* AComponent, Classes::TOperation Operation);
	DYNAMIC void __fastcall DoReadItem(System::TObject* Ini, const AnsiString Section, int Index, AnsiString &RecentName, int &UserData);
	DYNAMIC void __fastcall DoWriteItem(System::TObject* Ini, const AnsiString Section, int Index, const AnsiString RecentName, int UserData);
	DYNAMIC void __fastcall GetItemData(AnsiString &Caption, Classes::TShortCut &ShortCut, int UserData);
	DYNAMIC void __fastcall DoClick(const AnsiString RecentName, const AnsiString Caption, int UserData);
	
public:
	__fastcall virtual TMRUManager(Classes::TComponent* AOwner);
	__fastcall virtual ~TMRUManager(void);
	void __fastcall Add(const AnsiString RecentName, int UserData);
	void __fastcall Clear(void);
	HIDESBASE void __fastcall Remove(const AnsiString RecentName);
	void __fastcall UpdateRecentMenu(void);
	void __fastcall LoadFromRegistry(Registry::TRegIniFile* Ini, const AnsiString Section);
	void __fastcall SaveToRegistry(Registry::TRegIniFile* Ini, const AnsiString Section);
	void __fastcall LoadFromIni(Inifiles::TIniFile* Ini, const AnsiString Section);
	void __fastcall SaveToIni(Inifiles::TIniFile* Ini, const AnsiString Section);
	__property Classes::TStrings* Strings = {read=FList};
	
__published:
	__property TAccelDelimiter AccelDelimiter = {read=FAccelDelimiter, write=SetAccelDelimiter, default=0};
	__property bool AutoEnable = {read=FAutoEnable, write=SetAutoEnable, default=1};
	__property bool AutoUpdate = {read=FAutoUpdate, write=FAutoUpdate, default=1};
	__property int Capacity = {read=GetCapacity, write=SetCapacity, default=10};
	__property TRecentMode Mode = {read=GetMode, write=SetMode, default=0};
	__property bool RemoveOnSelect = {read=FRemoveOnSelect, write=FRemoveOnSelect, default=0};
	__property Placemnt::TFormPlacement* IniStorage = {read=GetStorage, write=SetStorage};
	__property Word SeparateSize = {read=FSeparateSize, write=SetSeparateSize, default=0};
	__property Menus::TMenuItem* RecentMenu = {read=FRecentMenu, write=SetRecentMenu};
	__property bool ShowAccelChar = {read=FShowAccelChar, write=SetShowAccelChar, default=1};
	__property unsigned StartAccel = {read=FStartAccel, write=SetStartAccel, default=1};
	__property Classes::TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
	__property TClickMenuEvent OnClick = {read=FOnClick, write=FOnClick};
	__property TGetItemEvent OnGetItemData = {read=FOnGetItem, write=FOnGetItem};
	__property TReadItemEvent OnReadItem = {read=FOnReadItem, write=FOnReadItem};
	__property TWriteItemEvent OnWriteItem = {read=FOnWriteItem, write=FOnWriteItem};
};


class DELPHICLASS TRecentStrings;
class PASCALIMPLEMENTATION TRecentStrings : public Classes::TStringList 
{
	typedef Classes::TStringList inherited;
	
private:
	int FMaxSize;
	TRecentMode FMode;
	void __fastcall SetMaxSize(int Value);
	
public:
	__fastcall TRecentStrings(void);
	virtual int __fastcall Add(const AnsiString S);
	virtual void __fastcall AddStrings(Classes::TStrings* Strings);
	void __fastcall DeleteExceed(void);
	void __fastcall Remove(const AnsiString S);
	__property int MaxSize = {read=FMaxSize, write=SetMaxSize, nodefault};
	__property TRecentMode Mode = {read=FMode, write=FMode, nodefault};
public:
	#pragma option push -w-inl
	/* TStringList.Destroy */ inline __fastcall virtual ~TRecentStrings(void) { }
	#pragma option pop
	
};


//-- var, const, procedure ---------------------------------------------------

}	/* namespace Mrulist */
using namespace Mrulist;
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// MRUList
