// Borland C++ Builder
// Copyright (c) 1995, 2002 by Borland Software Corporation
// All rights reserved

// (DO NOT EDIT: machine generated header) 'RxLogin.pas' rev: 6.00

#ifndef RxLoginHPP
#define RxLoginHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <Buttons.hpp>	// Pascal unit
#include <ExtCtrls.hpp>	// Pascal unit
#include <StdCtrls.hpp>	// Pascal unit
#include <Dialogs.hpp>	// Pascal unit
#include <Forms.hpp>	// Pascal unit
#include <Controls.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <Messages.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Rxlogin
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TUpdateCaption { ucNoChange, ucAppTitle, ucFormCaption };
#pragma option pop

typedef void __fastcall (__closure *TRxLoginEvent)(System::TObject* Sender, const AnsiString UserName, const AnsiString Password, bool &AllowLogin);

typedef bool __fastcall (__closure *TCheckUnlockEvent)(const AnsiString Password);

typedef void __fastcall (__closure *TUnlockAppEvent)(System::TObject* Sender, const AnsiString UserName, const AnsiString Password, bool &AllowUnlock);

class DELPHICLASS TRxCustomLogin;
class DELPHICLASS TRxLoginForm;
class PASCALIMPLEMENTATION TRxCustomLogin : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	bool FActive;
	int FAttemptNumber;
	AnsiString FLoggedUser;
	int FMaxPasswordLen;
	bool FAllowEmpty;
	TUpdateCaption FUpdateCaption;
	AnsiString FIniFileName;
	bool FUseRegistry;
	bool FLocked;
	bool FUnlockDlgShowing;
	Classes::TNotifyEvent FSaveOnRestore;
	Classes::TNotifyEvent FAfterLogin;
	Classes::TNotifyEvent FBeforeLogin;
	TCheckUnlockEvent FOnUnlock;
	TUnlockAppEvent FOnUnlockApp;
	Classes::TNotifyEvent FOnIconDblClick;
	AnsiString __fastcall GetLoggedUser();
	AnsiString __fastcall GetIniFileName();
	void __fastcall SetIniFileName(const AnsiString Value);
	bool __fastcall UnlockHook(Messages::TMessage &Message);
	
protected:
	DYNAMIC bool __fastcall CheckUnlock(const AnsiString UserName, const AnsiString Password);
	virtual TRxLoginForm* __fastcall CreateLoginForm(bool UnlockMode);
	DYNAMIC void __fastcall DoAfterLogin(void);
	DYNAMIC void __fastcall DoBeforeLogin(void);
	DYNAMIC void __fastcall DoIconDblCLick(System::TObject* Sender);
	virtual bool __fastcall DoLogin(AnsiString &UserName) = 0 ;
	virtual bool __fastcall DoUnlockDialog(void);
	void __fastcall SetLoggedUser(const AnsiString Value);
	void __fastcall DoUpdateCaption(void);
	void __fastcall UnlockOkClick(System::TObject* Sender);
	__property bool Active = {read=FActive, write=FActive, default=1};
	__property bool AllowEmptyPassword = {read=FAllowEmpty, write=FAllowEmpty, default=1};
	__property int AttemptNumber = {read=FAttemptNumber, write=FAttemptNumber, default=3};
	__property AnsiString IniFileName = {read=GetIniFileName, write=SetIniFileName};
	__property int MaxPasswordLen = {read=FMaxPasswordLen, write=FMaxPasswordLen, default=0};
	__property TUpdateCaption UpdateCaption = {read=FUpdateCaption, write=FUpdateCaption, default=0};
	__property bool UseRegistry = {read=FUseRegistry, write=FUseRegistry, default=0};
	__property Classes::TNotifyEvent AfterLogin = {read=FAfterLogin, write=FAfterLogin};
	__property Classes::TNotifyEvent BeforeLogin = {read=FBeforeLogin, write=FBeforeLogin};
	__property TCheckUnlockEvent OnUnlock = {read=FOnUnlock, write=FOnUnlock};
	__property TUnlockAppEvent OnUnlockApp = {read=FOnUnlockApp, write=FOnUnlockApp};
	__property Classes::TNotifyEvent OnIconDblClick = {read=FOnIconDblClick, write=FOnIconDblClick};
	
public:
	__fastcall virtual TRxCustomLogin(Classes::TComponent* AOwner);
	__fastcall virtual ~TRxCustomLogin(void);
	virtual bool __fastcall Login(void);
	void __fastcall TerminateApplication(void);
	void __fastcall Lock(void);
	__property AnsiString LoggedUser = {read=GetLoggedUser};
};


class DELPHICLASS TRxLoginDialog;
class PASCALIMPLEMENTATION TRxLoginDialog : public TRxCustomLogin 
{
	typedef TRxCustomLogin inherited;
	
private:
	TRxLoginEvent FOnCheckUser;
	void __fastcall OkButtonClick(System::TObject* Sender);
	void __fastcall WriteUserName(const AnsiString UserName);
	AnsiString __fastcall ReadUserName(const AnsiString UserName);
	
protected:
	DYNAMIC bool __fastcall DoCheckUser(const AnsiString UserName, const AnsiString Password);
	virtual bool __fastcall DoLogin(AnsiString &UserName);
	virtual void __fastcall Loaded(void);
	
__published:
	__property Active  = {default=1};
	__property AttemptNumber  = {default=3};
	__property IniFileName ;
	__property MaxPasswordLen  = {default=0};
	__property UpdateCaption  = {default=0};
	__property UseRegistry  = {default=0};
	__property TRxLoginEvent OnCheckUser = {read=FOnCheckUser, write=FOnCheckUser};
	__property AfterLogin ;
	__property BeforeLogin ;
	__property OnUnlockApp ;
	__property OnIconDblClick ;
public:
	#pragma option push -w-inl
	/* TRxCustomLogin.Create */ inline __fastcall virtual TRxLoginDialog(Classes::TComponent* AOwner) : TRxCustomLogin(AOwner) { }
	#pragma option pop
	#pragma option push -w-inl
	/* TRxCustomLogin.Destroy */ inline __fastcall virtual ~TRxLoginDialog(void) { }
	#pragma option pop
	
};


class PASCALIMPLEMENTATION TRxLoginForm : public Forms::TForm 
{
	typedef Forms::TForm inherited;
	
__published:
	Extctrls::TImage* AppIcon;
	Extctrls::TImage* KeyImage;
	Stdctrls::TLabel* HintLabel;
	Stdctrls::TLabel* UserNameLabel;
	Stdctrls::TLabel* PasswordLabel;
	Stdctrls::TEdit* UserNameEdit;
	Stdctrls::TEdit* PasswordEdit;
	Stdctrls::TLabel* AppTitleLabel;
	Stdctrls::TButton* OkBtn;
	Stdctrls::TButton* CancelBtn;
	Stdctrls::TLabel* CustomLabel;
	Stdctrls::TComboBox* CustomCombo;
	void __fastcall FormCreate(System::TObject* Sender);
	void __fastcall OkBtnClick(System::TObject* Sender);
	void __fastcall FormShow(System::TObject* Sender);
	
private:
	bool FSelectDatabase;
	bool FUnlockMode;
	int FAttempt;
	Classes::TNotifyEvent FOnFormShow;
	Classes::TNotifyEvent FOnOkClick;
	
public:
	int AttemptNumber;
	__property int Attempt = {read=FAttempt, nodefault};
	__property bool SelectDatabase = {read=FSelectDatabase, write=FSelectDatabase, nodefault};
	__property Classes::TNotifyEvent OnFormShow = {read=FOnFormShow, write=FOnFormShow};
	__property Classes::TNotifyEvent OnOkClick = {read=FOnOkClick, write=FOnOkClick};
public:
	#pragma option push -w-inl
	/* TCustomForm.Create */ inline __fastcall virtual TRxLoginForm(Classes::TComponent* AOwner) : Forms::TForm(AOwner) { }
	#pragma option pop
	#pragma option push -w-inl
	/* TCustomForm.CreateNew */ inline __fastcall virtual TRxLoginForm(Classes::TComponent* AOwner, int Dummy) : Forms::TForm(AOwner, Dummy) { }
	#pragma option pop
	#pragma option push -w-inl
	/* TCustomForm.Destroy */ inline __fastcall virtual ~TRxLoginForm(void) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TWinControl.CreateParented */ inline __fastcall TRxLoginForm(HWND ParentWindow) : Forms::TForm(ParentWindow) { }
	#pragma option pop
	
};


//-- var, const, procedure ---------------------------------------------------
extern PACKAGE TRxLoginForm* __fastcall CreateLoginDialog(bool UnlockMode, bool ASelectDatabase, Classes::TNotifyEvent FormShowEvent, Classes::TNotifyEvent OkClickEvent);

}	/* namespace Rxlogin */
using namespace Rxlogin;
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// RxLogin
